;####################################################
; WoodStock Logo v.1.0 : Delta Styles
;####################################################
; Informatik 1A: Projekt
;----------------------------------------------------
; BROCCO Amos
; BALABBIO Mara
; STOJANOVIC Tanja
;####################################################

(define drs-font-delta (make-object style-delta% 'change-family 'decorative))

(define modern-style-delta (make-object style-delta% 'change-family 'modern))
(define output-delta (make-object style-delta%
                         'change-weight
                         'bold))
(define result-delta (make-object style-delta%
                         'change-weight
                         'bold))
(define error-delta (make-object style-delta%
                        'change-style
                        'slant))

(send error-delta set-delta-foreground (make-object color% 255 0 0))
    
(send result-delta set-delta-foreground (make-object color% 0 0 175))
    
(send output-delta set-delta-foreground (make-object color% 150 0 150))

(define welcome-delta (make-object style-delta% 'change-family 'decorative))
    
(define red-delta (make-object style-delta%))

(define warning-style-delta (make-object style-delta% 'change-bold))

(send* warning-style-delta
    (set-delta-foreground "BLACK")
    (set-delta-background "YELLOW"))

(define (delta2 color style1 style2)
  (let ((theDelta (make-object style-delta% style1 style2)))
    (send theDelta set-delta-foreground color)))


(define (delta color)
  (let ((theDelta (make-object style-delta% 'change-nothing)))
    (send theDelta set-delta-foreground color)))

(define (find-last-newline-position Endpos)
  (define (iter pos)
    (if (> pos 0)
    (if (char=? (send TranscriptEditor get-character (- pos 1)) 
#\newline)
        pos
        (iter (- pos 1))) 0))
  (iter Endpos ))


(define (red-last-line)
  (let* ((Endpos (send transcripteditor get-end-position))
         (end-selection (find-last-newline-position Endpos))
         (start-selection (find-last-newline-position (- end-selection 
1))))
    (send transcripteditor change-style (delta "red") start-selection
end-selection)))

(define (blue-this-line)
  (let* ((end-selection (send transcripteditor get-end-position))
         (start-selection (find-last-newline-position end-selection)))
    (send transcripteditor change-style (delta "blue") start-selection
end-selection)))

(define (color-print string color)
    (print-to-transcript string)
    (send transcripteditor change-style (delta color) 
          (- (send transcripteditor get-end-position) (string-length (Converttostring string 1)))))

(define (delta-print string mydelta)
    (print-to-transcript string)
    (send transcripteditor change-style mydelta
          (- (send transcripteditor get-end-position) (string-length (Converttostring string 1)))))
  

  


